
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>MDSLibraries.phaser_wrapper &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for MDSLibraries.phaser_wrapper</h1><div class="highlight"><pre>
<span></span><span class="ch">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                               #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com          #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">argparse</span>
<span class="kn">import</span> <span class="nn">phaser</span>
<span class="kn">import</span> <span class="nn">pickle</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">inspect</span>


<div class="viewcode-block" id="process_inputs"><a class="viewcode-back" href="../../MDSLibraries.phaser_wrapper.html#MDSLibraries.phaser_wrapper.process_inputs">[docs]</a><span class="k">def</span> <span class="nf">process_inputs</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
    <span class="n">inputs</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;pickle&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">pickle</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;pickle&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mtz&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">mtz</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;mtz&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">pdb</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;pdb&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">mw</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;mw&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;identity&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">identity</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;identity&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">nc</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;nc&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;copies&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">copies</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;copies&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;I-F&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">REF_LABEL</span><span class="p">)</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;REF_LABEL&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;SIGI-SIGF&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">SIGMA_LABEL</span><span class="p">)</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;SIGMA_LABEL&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;kill&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">kill_after</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;kill&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mute&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">mute</span> <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="n">args</span><span class="p">,</span><span class="s2">&quot;mute&quot;</span><span class="p">)</span> <span class="k">else</span> <span class="kc">None</span>
    <span class="k">return</span> <span class="n">inputs</span></div>

<div class="viewcode-block" id="read_from_pickle"><a class="viewcode-back" href="../../MDSLibraries.phaser_wrapper.html#MDSLibraries.phaser_wrapper.read_from_pickle">[docs]</a><span class="k">def</span> <span class="nf">read_from_pickle</span><span class="p">(</span><span class="n">picklefile</span><span class="p">):</span>
    <span class="n">r</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">picklefile</span><span class="p">,</span> <span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">r</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">r</span></div>

<div class="viewcode-block" id="start_MR_DAT"><a class="viewcode-back" href="../../MDSLibraries.phaser_wrapper.html#MDSLibraries.phaser_wrapper.start_MR_DAT">[docs]</a><span class="k">def</span> <span class="nf">start_MR_DAT</span><span class="p">(</span><span class="n">inputs</span><span class="p">):</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mtz&quot;</span><span class="p">]</span>
    <span class="n">i</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">InputMR_DAT</span><span class="p">()</span>
    <span class="n">i</span><span class="o">.</span><span class="n">setHKLI</span><span class="p">(</span><span class="n">data</span><span class="p">)</span>
    <span class="k">if</span> <span class="s2">&quot;intensities&quot;</span> <span class="ow">in</span> <span class="n">inputs</span> <span class="ow">and</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;intensities&quot;</span><span class="p">]:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setLABI_I_SIGI</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;I-F&quot;</span><span class="p">],</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;SIGI-SIGF&quot;</span><span class="p">])</span>
    <span class="k">elif</span> <span class="s2">&quot;intensities&quot;</span> <span class="ow">in</span> <span class="n">inputs</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;intensities&quot;</span><span class="p">]:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setLABI_F_SIGF</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;I-F&quot;</span><span class="p">],</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;SIGI-SIGF&quot;</span><span class="p">])</span>
    <span class="k">elif</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;I-F&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;I&quot;</span><span class="p">):</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setLABI_I_SIGI</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;I-F&quot;</span><span class="p">],</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;SIGI-SIGF&quot;</span><span class="p">])</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setLABI_F_SIGF</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;I-F&quot;</span><span class="p">],</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;SIGI-SIGF&quot;</span><span class="p">])</span>
    <span class="c1">#print(inspect.getargspec(i.setREFL_F_SIGF))</span>
    <span class="c1"># i.setREFL_F_SIGF(data)</span>
    <span class="c1"># i.setHIRES(6.0)</span>
    <span class="n">i</span><span class="o">.</span><span class="n">setRESO_AUTO_OFF</span><span class="p">()</span>
    <span class="n">i</span><span class="o">.</span><span class="n">setMUTE</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mute&quot;</span><span class="p">])</span>

    <span class="n">r</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">runMR_DAT</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Job exit status FAILURE&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">r</span><span class="o">.</span><span class="n">ErrorName</span><span class="p">(),</span> <span class="s2">&quot;ERROR :&quot;</span><span class="p">,</span> <span class="n">r</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">())</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">r</span></div>

<div class="viewcode-block" id="start_MR_AUTO"><a class="viewcode-back" href="../../MDSLibraries.phaser_wrapper.html#MDSLibraries.phaser_wrapper.start_MR_AUTO">[docs]</a><span class="k">def</span> <span class="nf">start_MR_AUTO</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">explore_spacegroups</span><span class="o">=</span><span class="s2">&quot;ALL&quot;</span><span class="p">):</span>
        <span class="k">assert</span><span class="p">(</span><span class="s2">&quot;reflections&quot;</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">)</span>

        <span class="n">jobname</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mtz&quot;</span><span class="p">])[:</span><span class="o">-</span><span class="mi">4</span><span class="p">]</span>
        <span class="n">data</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mtz&quot;</span><span class="p">]</span>
        <span class="n">searches</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;searches&quot;</span><span class="p">]</span>
        <span class="n">fixed</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;fixed&quot;</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">fixed</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span> <span class="n">fixed</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">rootname</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;workingdir&quot;</span><span class="p">],</span><span class="n">jobname</span><span class="p">)</span>
        <span class="n">modelname</span> <span class="o">=</span> <span class="n">jobname</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">si</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;identity&quot;</span><span class="p">]</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">pass</span>
        <span class="n">mw</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">]</span>
        <span class="n">nc</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">]</span>
        <span class="n">reflections</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;reflections&quot;</span><span class="p">]</span>

        <span class="n">i</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">InputMR_AUTO</span><span class="p">()</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setMUTE</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mute&quot;</span><span class="p">])</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setREFL_DATA</span><span class="p">(</span><span class="n">reflections</span><span class="o">.</span><span class="n">getREFL_DATA</span><span class="p">())</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setROOT</span><span class="p">(</span><span class="n">rootname</span><span class="p">)</span>

        <span class="c1">#NOTE: Commented for fast debug</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="s2">&quot;new_spacegroup&quot;</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">setSGAL_SELE</span><span class="p">(</span><span class="n">explore_spacegroups</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">addCOMP_PROT_MW_NUM</span><span class="p">(</span><span class="n">mw</span><span class="p">,</span> <span class="n">nc</span><span class="p">)</span>

        <span class="n">modelnames</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">mmdi</span> <span class="o">=</span> <span class="p">{}</span>

        <span class="k">if</span> <span class="s2">&quot;new_spacegroup&quot;</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">num</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;new_spacegroup&quot;</span><span class="p">]</span>
                <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NUM</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">num</span><span class="p">))</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">spgr0</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;new_spacegroup&quot;</span><span class="p">]</span>
                    <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">spgr0</span><span class="p">))</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="k">try</span><span class="p">:</span>
                        <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;new_spacegroup&quot;</span><span class="p">])</span>
                    <span class="k">except</span><span class="p">:</span>
                        <span class="k">try</span><span class="p">:</span>
                            <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_HALL</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;new_spacegroup&quot;</span><span class="p">])</span>
                        <span class="k">except</span><span class="p">:</span>
                            <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="n">reflections</span><span class="o">.</span><span class="n">getSpaceGroupName</span><span class="p">())</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="n">reflections</span><span class="o">.</span><span class="n">getSpaceGroupName</span><span class="p">())</span>

        <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">fixed</span><span class="p">:</span>
            <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">])</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_ID</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">],</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;identity&quot;</span><span class="p">])</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_CARD</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">],</span> <span class="kc">True</span><span class="p">)</span>
            <span class="n">i</span><span class="o">.</span><span class="n">setENSE_DISA_CHEC</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="kc">True</span><span class="p">)</span>

            <span class="c1">#i.addSEAR_ENSE_NUM(sol[&quot;modlid&quot;], 1)</span>


        <span class="k">for</span> <span class="n">search</span> <span class="ow">in</span> <span class="n">searches</span><span class="p">:</span>
            <span class="n">name</span><span class="p">,</span><span class="n">maxllg</span><span class="p">,</span><span class="n">nasu</span><span class="p">,</span><span class="n">pdblist</span> <span class="o">=</span> <span class="n">search</span>
            <span class="n">modelis</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">y</span><span class="p">,</span><span class="n">ppdd</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">pdblist</span><span class="p">):</span>
                <span class="n">modelis</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">name</span><span class="o">+</span><span class="s2">&quot;__&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">y</span><span class="p">))</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_ID</span><span class="p">(</span><span class="n">name</span><span class="o">+</span><span class="s2">&quot;__&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">y</span><span class="p">),</span> <span class="n">ppdd</span><span class="p">,</span> <span class="n">si</span><span class="p">)</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_CARD</span><span class="p">(</span><span class="n">name</span><span class="o">+</span><span class="s2">&quot;__&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">y</span><span class="p">),</span> <span class="n">ppdd</span><span class="p">,</span> <span class="kc">True</span><span class="p">)</span>
                <span class="n">mmdi</span><span class="p">[</span><span class="n">name</span><span class="o">+</span><span class="s2">&quot;__&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">y</span><span class="p">)]</span> <span class="o">=</span> <span class="n">ppdd</span>
            <span class="n">modelnames</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">modelis</span><span class="p">,</span> <span class="n">nasu</span><span class="p">))</span>

        <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">fixed</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addSOLU_ORIG_ENSE</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]))</span>
            <span class="c1">#i.addSOLU_6DIM_ENSE(str(sol[&quot;modlid&quot;]), [0.0, 0.0, 0.0], True, [0.0, 0.0, 0.0], 1, False, False, False, 0.0, 1)</span>

        <span class="k">for</span> <span class="n">modelcopy</span> <span class="ow">in</span> <span class="n">modelnames</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;modelcopy&quot;</span><span class="p">,</span> <span class="n">modelcopy</span><span class="p">)</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addSEAR_ENSE_OR_ENSE_NUM</span><span class="p">(</span><span class="n">modelcopy</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">modelcopy</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
        <span class="c1">#i.addSEAR_ENSE_NUM(modelname, cpsearch)</span>

        <span class="n">i</span><span class="o">.</span><span class="n">addMACM</span><span class="p">(</span><span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">False</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>

        <span class="c1">#i.setPURG_ROTA_ENAB(True)</span>
        <span class="c1">#i.setPURG_TRAN_ENAB(True)</span>
        <span class="c1">#i.setPURG_ROTA_PERC(80)</span>
        <span class="c1">#i.setPURG_TRAN_PERC(80)</span>

        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;==============================INPUTS===============================&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">inputs</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;==============================INPUTS===============================&quot;</span><span class="p">)</span>

        <span class="n">r</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">runMR_AUTO</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Job exit status FAILURE&quot;</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">r</span><span class="o">.</span><span class="n">ErrorName</span><span class="p">(),</span> <span class="s2">&quot;ERROR :&quot;</span><span class="p">,</span> <span class="n">r</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">())</span>
            <span class="k">return</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">foundSolutions</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Phaser has not found any MR solutions&quot;</span><span class="p">)</span>
            <span class="c1">#return</span>

        <span class="k">if</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Phaser has found MR solutions&quot;</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Top LLG = </span><span class="si">%f</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">r</span><span class="o">.</span><span class="n">getTopLLG</span><span class="p">())</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Top PDB file = </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">r</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">())</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">pickling</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">jobname</span> <span class="o">+</span> <span class="s2">&quot;.pickle&quot;</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">p</span><span class="p">:</span>
                <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">r</span><span class="p">,</span> <span class="n">p</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">r</span><span class="p">,</span> <span class="n">mmdi</span></div>

<div class="viewcode-block" id="start_MR_RNP"><a class="viewcode-back" href="../../MDSLibraries.phaser_wrapper.html#MDSLibraries.phaser_wrapper.start_MR_RNP">[docs]</a><span class="k">def</span> <span class="nf">start_MR_RNP</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">already_in_place</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">do_not_refine</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="k">assert</span><span class="p">(</span><span class="s2">&quot;reflections&quot;</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">)</span>

        <span class="n">jobname</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;jobname&quot;</span><span class="p">]</span>
        <span class="n">rootname</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;workingdir&quot;</span><span class="p">],</span><span class="n">jobname</span><span class="p">)</span>
        <span class="n">mw</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">]</span>
        <span class="n">nc</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">]</span>
        <span class="n">reflections</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;reflections&quot;</span><span class="p">]</span>

        <span class="n">i</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">InputMR_RNP</span><span class="p">()</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setMUTE</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mute&quot;</span><span class="p">])</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setREFL_DATA</span><span class="p">(</span><span class="n">reflections</span><span class="o">.</span><span class="n">getREFL_DATA</span><span class="p">())</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setROOT</span><span class="p">(</span><span class="n">rootname</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">addCOMP_PROT_MW_NUM</span><span class="p">(</span><span class="n">mw</span><span class="p">,</span> <span class="n">nc</span><span class="p">)</span>

        <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]:</span>
            <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">])</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_ID</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">],</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;identity&quot;</span><span class="p">])</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_CARD</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">],</span> <span class="kc">True</span><span class="p">)</span>
            <span class="c1">#i.addSEAR_ENSE_NUM(sol[&quot;modlid&quot;], 1)</span>

        <span class="k">if</span> <span class="s2">&quot;new_spacegroup&quot;</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;new_spacegroup&quot;</span><span class="p">])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="n">reflections</span><span class="o">.</span><span class="n">getSpaceGroupName</span><span class="p">())</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setXYZO</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">do_not_refine</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">setMACM_PROT</span><span class="p">(</span><span class="s2">&quot;OFF&quot;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addMACM</span><span class="p">(</span><span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">False</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
            <span class="n">i</span><span class="o">.</span><span class="n">setMACM_CHAI</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">already_in_place</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addSOLU_SET</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]:</span>
                <span class="n">i</span><span class="o">.</span><span class="n">addSOLU_6DIM_ENSE</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">],</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;euler&quot;</span><span class="p">],</span> <span class="kc">True</span><span class="p">,</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;frac&quot;</span><span class="p">],</span> <span class="nb">float</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;bfac&quot;</span><span class="p">]),</span> <span class="kc">False</span><span class="p">,</span> <span class="kc">False</span><span class="p">,</span> <span class="kc">False</span><span class="p">,</span> <span class="nb">float</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;mult&quot;</span><span class="p">]),</span> <span class="nb">float</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;ofac&quot;</span><span class="p">]))</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]:</span>
                <span class="n">i</span><span class="o">.</span><span class="n">addSOLU_ORIG_ENSE</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">])</span>

        <span class="c1"># print(&quot;==============================INPUTS===============================&quot;)</span>
        <span class="c1"># print(inputs)</span>
        <span class="c1"># print(&quot;==============================INPUTS===============================&quot;)</span>

        <span class="n">r</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">runMR_RNP</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Job exit status FAILURE&quot;</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">r</span><span class="o">.</span><span class="n">ErrorName</span><span class="p">(),</span> <span class="s2">&quot;ERROR :&quot;</span><span class="p">,</span> <span class="n">r</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">())</span>
            <span class="k">return</span> <span class="kc">None</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">foundSolutions</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Phaser has not found any MR solutions&quot;</span><span class="p">)</span>
            <span class="c1">#return</span>

        <span class="k">if</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Phaser has found MR solutions&quot;</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Top LLG = </span><span class="si">%f</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">r</span><span class="o">.</span><span class="n">getTopLLG</span><span class="p">())</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Top PDB file = </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">r</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">())</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">pickling</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">jobname</span> <span class="o">+</span> <span class="s2">&quot;.pickle&quot;</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">p</span><span class="p">:</span>
                <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">r</span><span class="p">,</span> <span class="n">p</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">r</span></div>

<div class="viewcode-block" id="start_NMA"><a class="viewcode-back" href="../../MDSLibraries.phaser_wrapper.html#MDSLibraries.phaser_wrapper.start_NMA">[docs]</a><span class="k">def</span> <span class="nf">start_NMA</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">already_in_place</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">step</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span> <span class="n">max_rms</span><span class="o">=</span><span class="mf">3.0</span><span class="p">):</span>
        <span class="n">jobname</span> <span class="o">=</span> <span class="s2">&quot;NMA&quot;</span>
        <span class="n">pdb</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">]</span>
        <span class="n">rootname</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;workingdir&quot;</span><span class="p">],</span><span class="n">jobname</span><span class="p">)</span>
        <span class="n">modelname</span> <span class="o">=</span> <span class="n">jobname</span>

        <span class="n">i</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">InputNMA</span><span class="p">()</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setMUTE</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mute&quot;</span><span class="p">])</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setROOT</span><span class="p">(</span><span class="n">rootname</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_ID</span><span class="p">(</span><span class="n">modelname</span><span class="p">,</span> <span class="n">pdb</span><span class="p">,</span> <span class="mi">100</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setXYZO</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">addNMA_MODE</span><span class="p">(</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setNMA_COMB</span><span class="p">(</span><span class="mi">2</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setPERT_INCR</span><span class="p">(</span><span class="s2">&quot;RMS&quot;</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setPERT_RMS_STEP</span><span class="p">(</span><span class="n">step</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setPERT_RMS_MAXI</span><span class="p">(</span><span class="n">max_rms</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setJOBS</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setKILL_TIME</span><span class="p">(</span><span class="mi">3</span><span class="p">)</span>

        <span class="n">r</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">runNMAXYZ</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">()</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Job exit status FAILURE&quot;</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">r</span><span class="o">.</span><span class="n">ErrorName</span><span class="p">(),</span> <span class="s2">&quot;ERROR :&quot;</span><span class="p">,</span> <span class="n">r</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">())</span>
            <span class="k">return</span> <span class="kc">None</span>

        <span class="c1"># if r.Success():</span>
        <span class="c1">#     print(&quot;Phaser has performed NMA&quot;)</span>

        <span class="k">if</span> <span class="n">pickling</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">jobname</span> <span class="o">+</span> <span class="s2">&quot;.pickle&quot;</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">p</span><span class="p">:</span>
                <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">r</span><span class="p">,</span> <span class="n">p</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">r</span></div>

<div class="viewcode-block" id="start_MR_OCC"><a class="viewcode-back" href="../../MDSLibraries.phaser_wrapper.html#MDSLibraries.phaser_wrapper.start_MR_OCC">[docs]</a><span class="k">def</span> <span class="nf">start_MR_OCC</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">pickling</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">already_in_place</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">do_not_refine</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="k">assert</span> <span class="p">(</span><span class="s2">&quot;reflections&quot;</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">)</span>

    <span class="n">jobname</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;jobname&quot;</span><span class="p">]</span>
    <span class="n">rootname</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;workingdir&quot;</span><span class="p">],</span><span class="n">jobname</span><span class="p">)</span>
    <span class="n">mw</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mw&quot;</span><span class="p">]</span>
    <span class="n">nc</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;nc&quot;</span><span class="p">]</span>
    <span class="n">reflections</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;reflections&quot;</span><span class="p">]</span>

    <span class="n">i</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">InputMR_OCC</span><span class="p">()</span>
    <span class="n">i</span><span class="o">.</span><span class="n">setMUTE</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;mute&quot;</span><span class="p">])</span>
    <span class="n">i</span><span class="o">.</span><span class="n">setREFL_DATA</span><span class="p">(</span><span class="n">reflections</span><span class="o">.</span><span class="n">getREFL_DATA</span><span class="p">())</span>
    <span class="n">i</span><span class="o">.</span><span class="n">setROOT</span><span class="p">(</span><span class="n">rootname</span><span class="p">)</span>
    <span class="n">i</span><span class="o">.</span><span class="n">addCOMP_PROT_MW_NUM</span><span class="p">(</span><span class="n">mw</span><span class="p">,</span> <span class="n">nc</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]:</span>
        <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">])</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_ID</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">],</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;identity&quot;</span><span class="p">])</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addENSE_PDB_CARD</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;pdb&quot;</span><span class="p">],</span> <span class="kc">True</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setENSE_DISA_CHEC</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">]),</span> <span class="kc">True</span><span class="p">)</span>
        <span class="c1"># i.addSEAR_ENSE_NUM(sol[&quot;modlid&quot;], 1)</span>

    <span class="k">if</span> <span class="s2">&quot;new_spacegroup&quot;</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;new_spacegroup&quot;</span><span class="p">])</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setSPAC_NAME</span><span class="p">(</span><span class="n">reflections</span><span class="o">.</span><span class="n">getSpaceGroupName</span><span class="p">())</span>

    <span class="n">i</span><span class="o">.</span><span class="n">setXYZO</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">do_not_refine</span><span class="p">:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setMACM_PROT</span><span class="p">(</span><span class="s2">&quot;OFF&quot;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">addMACM</span><span class="p">(</span><span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">False</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
        <span class="n">i</span><span class="o">.</span><span class="n">setMACM_CHAI</span><span class="p">(</span><span class="kc">True</span><span class="p">)</span>

    <span class="k">if</span> <span class="ow">not</span> <span class="n">already_in_place</span><span class="p">:</span>
        <span class="n">i</span><span class="o">.</span><span class="n">addSOLU_SET</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addSOLU_6DIM_ENSE</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">],</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;euler&quot;</span><span class="p">],</span> <span class="kc">True</span><span class="p">,</span> <span class="n">sol</span><span class="p">[</span><span class="s2">&quot;frac&quot;</span><span class="p">],</span> <span class="nb">float</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;bfac&quot;</span><span class="p">]),</span> <span class="kc">False</span><span class="p">,</span> <span class="kc">False</span><span class="p">,</span> <span class="kc">False</span><span class="p">,</span>
                                <span class="nb">float</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;mult&quot;</span><span class="p">]),</span> <span class="nb">float</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;ofac&quot;</span><span class="p">]))</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">sol</span> <span class="ow">in</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;sol&quot;</span><span class="p">]:</span>
            <span class="n">i</span><span class="o">.</span><span class="n">addSOLU_ORIG_ENSE</span><span class="p">(</span><span class="n">sol</span><span class="p">[</span><span class="s2">&quot;modlid&quot;</span><span class="p">])</span>

    <span class="c1"># print(&quot;==============================INPUTS===============================&quot;)</span>
    <span class="c1"># print(inputs)</span>
    <span class="c1"># print(&quot;==============================INPUTS===============================&quot;)</span>

    <span class="n">r</span> <span class="o">=</span> <span class="n">phaser</span><span class="o">.</span><span class="n">runMR_OCC</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>

    <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Job exit status FAILURE&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">r</span><span class="o">.</span><span class="n">ErrorName</span><span class="p">(),</span> <span class="s2">&quot;ERROR :&quot;</span><span class="p">,</span> <span class="n">r</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">())</span>
        <span class="k">return</span> <span class="kc">None</span>

    <span class="k">if</span> <span class="ow">not</span> <span class="n">r</span><span class="o">.</span><span class="n">foundSolutions</span><span class="p">():</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Phaser has not found any MR solutions&quot;</span><span class="p">)</span>
        <span class="c1"># return</span>

    <span class="k">if</span> <span class="n">r</span><span class="o">.</span><span class="n">Success</span><span class="p">():</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Phaser has found MR solutions&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Top LLG = </span><span class="si">%f</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">r</span><span class="o">.</span><span class="n">getTopLLG</span><span class="p">())</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Top PDB file = </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">r</span><span class="o">.</span><span class="n">getTopPdbFile</span><span class="p">())</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">pickling</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">jobname</span> <span class="o">+</span> <span class="s2">&quot;.pickle&quot;</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">p</span><span class="p">:</span>
            <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">r</span><span class="p">,</span> <span class="n">p</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">r</span></div>



<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">errstream</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">stderr</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">stderr</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">stdout</span>

    <span class="n">parser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span><span class="n">description</span><span class="o">=</span><span class="s1">&#39;Command line options for MR_AUTO&#39;</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--pickle&quot;</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Open and parse a pickled MR_AUTO run&quot;</span><span class="p">,</span> <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store&#39;</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--mtz&quot;</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Reflections in mtz format&quot;</span><span class="p">,</span> <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store&#39;</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--pdb&quot;</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Model for MR&quot;</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--mw&quot;</span><span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;Molecular weight in Dalton&quot;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">float</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--identity&quot;</span><span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;The indentity of the model vs target in fraction&quot;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">float</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--nc&quot;</span><span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;Number of comoponent in the asymmetric unit. Default is 1.&quot;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--copies&quot;</span><span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;Number of times that the pdb model must be searched. Default 1&quot;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--REF_LABEL&quot;</span><span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;I or F label. Default&quot;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="s2">&quot;I&quot;</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--SIGMA_LABEL&quot;</span><span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;SIGI or SIGF label. Default&quot;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="s2">&quot;SIGI&quot;</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--mute&quot;</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Mute Phaser Log. Default False&quot;</span><span class="p">,</span> <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s2">&quot;--kill_after&quot;</span><span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;Kill phaser job after specified seconds. Default -1 which means not kill.&quot;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span> <span class="n">default</span><span class="o">=-</span><span class="mi">1</span><span class="p">)</span>

    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;*******************************************COMMAND LINE**************************************************&quot;</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">))</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;*********************************************************************************************************&quot;</span><span class="p">)</span>

    <span class="n">args</span> <span class="o">=</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse_args</span><span class="p">()</span>
    <span class="n">sys</span><span class="o">.</span><span class="n">stderr</span> <span class="o">=</span> <span class="n">errstream</span>

    <span class="n">inputs</span> <span class="o">=</span> <span class="n">process_inputs</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="n">result</span> <span class="o">=</span> <span class="kc">None</span>
    <span class="k">if</span> <span class="s2">&quot;pickle&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">inputs</span> <span class="ow">or</span> <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;pickle&quot;</span><span class="p">]</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">reflections</span> <span class="o">=</span> <span class="n">start_MR_DAT</span><span class="p">(</span><span class="n">inputs</span><span class="p">)</span>
        <span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;reflections&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">reflections</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">start_MR_AUTO</span><span class="p">(</span><span class="n">inputs</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">read_from_pickle</span><span class="p">(</span><span class="n">inputs</span><span class="p">[</span><span class="s2">&quot;pickle&quot;</span><span class="p">])</span>

    <span class="nb">print</span><span class="p">(</span><span class="nb">dir</span><span class="p">(</span><span class="n">result</span><span class="p">))</span>


</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>